Mention the --inplace new-file permissions fix.
[rsync/rsync.git] / runtests.sh
CommitLineData
e7d29902
MP
1#! /bin/sh
2
cf72f204 3# Copyright (C) 2001, 2002 by Martin Pool <mbp@samba.org>
e7d29902
MP
4
5# This program is free software; you can redistribute it and/or modify
a4cf6bec
MP
6# it under the terms of the GNU General Public License version
7# 2 as published by the Free Software Foundation.
e7d29902
MP
8#
9# This program is distributed in the hope that it will be useful, but
10# WITHOUT ANY WARRANTY; without even the implied warranty of
11# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
12# Lesser General Public License for more details.
13#
14# You should have received a copy of the GNU Lesser General Public
15# License along with this program; if not, write to the Free Software
16# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
17
18
19# rsync top-level test script -- this invokes all the other more
20# detailed tests in order. This script can either be called by `make
21# check' or `make installcheck'. `check' runs against the copies of
22# the program and other files in the build directory, and
23# `installcheck' against the installed copy of the program.
24
25# In either case we need to also be able to find the source directory,
26# since we read test scripts and possibly other information from
27# there.
28
29# Whenever possible, informational messages are written to stdout and
30# error messages to stderr. They're separated out by the build farm
31# display scripts.
32
33# According to the GNU autoconf manual, the only valid place to set up
34# directory locations is through Make, since users are allowed to (try
35# to) change their mind on the Make command line. So, Make has to
36# pass in all the values we need.
37
38# For other configured settings we read ./config.sh, which tells us
39# about shell commands on this machine and similar things.
40
41# rsync_bin gives the location of the rsync binary. This is either
42# builddir/rsync if we're testing an uninstalled copy, or
43# install_prefix/bin/rsync if we're testing an installed copy. On the
44# build farm rsync will be installed, but into a scratch /usr.
45
46# srcdir gives the location of the source tree, which lets us find the
47# build scripts. At the moment we assume we are invoked from the
48# source directory.
49
50# This script must be invoked from the build directory.
51
52# A scratch directory, 'testtmp', is created in the build directory to
53# hold working files.
54
3a4c683f
MP
55# This script also uses the $loglevel environment variable. 1 is the
56# default value, and 10 the most verbose. You can set this from the
57# Make command line. It's also set by the build farm to give more
58# detail for failing builds.
59
60
61# NOTES FOR TEST CASES:
62
63# Each test case runs in its own shell.
e7d29902 64
12b9c840 65# Exit codes from tests:
e7d29902
MP
66
67# 1 tests failed
68# 2 error in starting tests
3a4c683f
MP
69# 77 this test skipped (random value unlikely to happen by chance, same as
70# automake)
71
12b9c840
MP
72# HOWEVER, the overall exit code to the farm is different: we return
73# the *number of tests that failed*, so that it will show up nicely in
74# the overall summary.
75
3a4c683f
MP
76# rsync.fns contains some general setup functions and definitions.
77
78
79# NOTES ON PORTABILITY:
80
81# Both this script and the Makefile have to be pretty conservative
82# about which Unix features they use.
83
84# We cannot count on Make exporting variables to commands, unless
85# they're explicitly given on the command line.
86
87# Also, we can't count on 'cp -a' or 'mkdir -p', although they're
88# pretty handy.
89
d286ee98
MP
90# I think some of the GNU documentation suggests that we shouldn't
91# rely on shell functions. However, the Bash manual seems to say that
92# they're in POSIX 1003.2, and since the build farm relies on them
93# they're probably working on most machines we really care about.
e7d29902 94
4a7cb3e8
MP
95# You cannot use "function foo {" syntax, but must instead say "foo()
96# {", or it breaks on FreeBSD.
97
571a4b26
MP
98# BSD machines tend not to have "head" or "seq".
99
6cd7888e
MP
100# You cannot do "export VAR=VALUE" all on one line; the export must be
101# separate from the assignment. (SCO SysV)
102
e7d29902 103
c36b5017
MP
104
105# STILL TO DO:
106
107# We need a good protection against tests that hang indefinitely.
108# Perhaps some combination of starting them in the background, wait,
109# and kill?
110
111# Perhaps we need a common way to cleanup tests. At the moment just
112# clobbering the directory when we're done should be enough.
113
f7ca98bd
MP
114# If any of the targets fail, then (GNU?) Make returns 2, instead of
115# the return code from the failing command. This is fine, but it
116# means that the build farm just shows "2" for failed tests, not the
117# number of tests that actually failed. For more details we might
118# need to grovel through the log files to find a line saying how many
119# failed.
120
c36b5017 121
e7d29902
MP
122set -e
123
124. "./shconfig"
125
3a4c683f
MP
126RUNSHFLAGS='-e'
127
017f22b4 128# for Solaris
30fa7724 129[ -d /usr/xpg4/bin ] && PATH="/usr/xpg4/bin/:$PATH"
017f22b4 130
30fa7724
WD
131if [ "x$loglevel" != x ] && [ "$loglevel" -gt 8 ]; then
132 if set -x; then
42e66aa2
MP
133 # If it doesn't work the first time, don't keep trying.
134 RUNSHFLAGS="$RUNSHFLAGS -x"
135 fi
3a4c683f 136fi
e7d29902
MP
137
138echo "============================================================"
139echo "$0 running in `pwd`"
140echo " rsync_bin=$rsync_bin"
141echo " srcdir=$srcdir"
142
30fa7724 143if [ -f /usr/bin/whoami ]; then
19cb6106 144 testuser=`/usr/bin/whoami`
30fa7724 145elif [ -f /usr/ucb/whoami ]; then
19cb6106 146 testuser=`/usr/ucb/whoami`
13d00101
WD
147elif [ -f /bin/whoami ]; then
148 testuser=`/bin/whoami`
19cb6106 149else
13d00101 150 testuser=`id -un 2>/dev/null || echo ${LOGNAME:-${USERNAME:-${USER:-'UNKNOWN'}}}`
19cb6106 151fi
53e1f937
MP
152
153echo " testuser=$testuser"
154echo " os=`uname -a`"
155
d1239eae 156# It must be "yes", not just nonnull
30fa7724 157if [ "x$preserve_scratch" = xyes ]; then
d1239eae
MP
158 echo " preserve_scratch=yes"
159else
160 echo " preserve_scratch=no"
161fi
162
163
30fa7724 164if [ ! -f "$rsync_bin" ]; then
e7d29902
MP
165 echo "rsync_bin $rsync_bin is not a file" >&2
166 exit 2
167fi
168
30fa7724 169if [ ! -d "$srcdir" ]; then
e7d29902
MP
170 echo "srcdir $srcdir is not a directory" >&2
171 exit 2
172fi
173
78ffe478 174RSYNC="$rsync_bin"
f5d96a6f 175#RSYNC="valgrind --tool=addrcheck $rsync_bin"
e7d29902 176
78ffe478 177export rsync_bin RSYNC
e7d29902
MP
178
179skipped=0
180missing=0
181passed=0
182failed=0
183
cf72f204
MP
184# Prefix for scratch directory. We create separate directories for
185# each test case, so that they can be left behind in case of failure
186# to aid investigation.
187scratchbase="`pwd`"/testtmp
188echo " scratchbase=$scratchbase"
78ffe478 189
e7d29902
MP
190suitedir="$srcdir/testsuite"
191
3a4c683f
MP
192export scratchdir suitedir
193
cf72f204 194prep_scratch() {
b214eda4
MP
195 [ -d "$scratchdir" ] && rm -rf "$scratchdir"
196 mkdir "$scratchdir"
cf72f204
MP
197 return 0
198}
199
c019068f
MP
200maybe_discard_scratch() {
201 [ x"$preserve_scratch" != xyes ] && [ -d "$scratchdir" ] && rm -rf "$scratchdir"
cf72f204 202 return 0
b214eda4
MP
203}
204
30fa7724 205if [ "x$whichtests" = x ]; then
c36b5017
MP
206 whichtests="*.test"
207fi
208
209for testscript in $suitedir/$whichtests
e7d29902 210do
89a9c054 211 testbase=`echo $testscript | sed -e 's!.*/!!' -e 's/.test\$//'`
cf72f204 212 scratchdir="$scratchbase.$testbase"
e7d29902 213
cf72f204 214 prep_scratch
e7d29902 215
cf72f204
MP
216 set +e
217 sh $RUNSHFLAGS "$testscript" >"$scratchdir/test.log" 2>&1
218 result=$?
219 set -e
220
c019068f
MP
221 if [ "x$always_log" = xyes -o \( $result != 0 -a $result != 77 -a $result != 78 \) ]
222 then
223 echo "----- $testbase log follows"
224 cat "$scratchdir/test.log"
225 echo "----- $testbase log ends"
53adbd7a
WD
226 if [ -f "$scratchdir/rsyncd.log" ]; then
227 echo "----- $testbase rsyncd.log follows"
228 cat "$scratchdir/rsyncd.log"
229 echo "----- $testbase rsyncd.log ends"
230 fi
c019068f
MP
231 fi
232
cf72f204
MP
233 case $result in
234 0)
f08aacf7 235 echo "PASS $testbase"
e7d29902 236 passed=`expr $passed + 1`
c019068f 237 maybe_discard_scratch
cf72f204
MP
238 ;;
239 77)
7d821932 240 # backticks will fill the whole file onto one line, which is a feature
1657be22
WD
241 whyskipped=`cat "$scratchdir/whyskipped"`
242 echo "SKIP $testbase ($whyskipped)"
cf72f204 243 skipped=`expr $skipped + 1`
c019068f 244 maybe_discard_scratch
cf72f204 245 ;;
be2f866b
MP
246 78)
247 # It failed, but we expected that. don't dump out error logs,
248 # because most users won't want to see them. But do leave
249 # the working directory around.
250 echo "XFAIL $testbase"
251 failed=`expr $failed + 1`
252 ;;
cf72f204 253 *)
f08aacf7 254 echo "FAIL $testbase"
cf72f204 255 failed=`expr $failed + 1`
30fa7724 256 if [ "x$nopersist" = xyes ]; then
cf72f204
MP
257 exit 1
258 fi
259 esac
e7d29902
MP
260done
261
262echo '------------------------------------------------------------'
263echo "----- overall results:"
264echo " $passed passed"
ec99e9da
MP
265[ "$failed" -gt 0 ] && echo " $failed failed"
266[ "$skipped" -gt 0 ] && echo " $skipped skipped"
267[ "$missing" -gt 0 ] && echo " $missing missing"
e7d29902
MP
268echo '------------------------------------------------------------'
269
32c58f06
MP
270# OK, so expr exits with 0 if the result is neither null nor zero; and
271# 1 if the expression is null or zero. This is the opposite of what
272# we want, and if we just call expr then this script will always fail,
273# because -e is set.
274
32c58f06
MP
275result=`expr $failed + $missing || true`
276echo "overall result is $result"
d2476f0d 277exit $result